#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

bool check(long long k) {
	if (k % 2 == 0)
		return false;
	for (long long i = 3; i * i <= k; i += 2) {
		if (k % i == 0) 
			return false;
	}
	return true;
}

long long get(long long k) {
	if (k < 0 && (long long)sqrtl(-k) * (long long)sqrt(-k) == abs(k)) {
		return 0;
	}
	if ((abs(k) - 2) % 4 == 0)
		return -1;
	if (check(k)) {
		return abs(k + 1) / 2;
	}
	for (long long i = 0; i < 1e7; i++) {
		long long val = i * i + k;
		if (val < 0)
			continue;
		long long s = sqrtl(val);
		if (s * s == val) {
			return s;
		}
	}
	return -1;
}

int main() {
	/*for (int i = -30; i < 30; i++) {
		cout << i << ": " << get(i) << endl;
	}
	cout << "Okay\n";*/
	long long k; cin >> k;
	long long got = get(k);
	if (got == -1) {
		cout << "none\n";
	} else {
		cout << got << endl;
	}
	//system("pause");
}