#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
using namespace std;

const int MAXN = 1e5;

int n, m;

vector<int> a;
vector<int> need;

void solve_sq() {
	vector<int> ans;
	for (int cur = 0; cur < m; cur++) {
		while (true) {
			int x = a[0];
			int now = -1;
			vector<bool> used(n);
			int cnt = 0;
			for (int i = cur + 1; i < m; i++) {
				cnt += !used[need[i]];
				used[need[i]] = true;
				if (need[i] == x) {
					now = i;
					break;
				}
			}
			cnt += !used[need[cur]];
			used[need[cur]] = true;
			if (now == -1) {
				a.erase(a.begin());
				a.push_back(x);
				ans.push_back(n);
			}
			else {
				for (int i = 0; i < n; i++) {
					cnt -= used[a[i]];
					used[a[i]] = false;
					if (cnt == 0) {
						ans.push_back(i + 1);
						if (i == n - 1)
							a.push_back(x);
						else
							a.insert(a.begin() + i + 1, x);
						a.erase(a.begin());
						break;
					}
				}

			}
			if (x == need[cur])
				break;
		}
	}
	cout << (int)ans.size() << endl;
	for (auto &x : ans) {
		cout << x << " ";
	}
	cout << endl;
}

void solve_fir() {
	cout << n << endl;
	for (int i = 0; i < n; i++) {
		cout << n << " ";
	}
	cout << endl;
}

void solve_sec() {
	cout << 2 * n - 1 << endl;
	for (int i = 0; i < n - 1; i++) {
		cout << n - i << " ";
	}

	for (int i = 0; i < n; i++) {
		cout << n << " ";
	}
	cout << endl;
}

void solve_un() {
	map<int, int> was;
	vector<bool> used;
	int ans[MAXN] = {};
	fill(ans, ans + MAXN, -1);
	int timer = 0;
	int it = 0;
	vector<pair<int, int>> got;
	for (int i = 0; i < m; i++) {
		if (was.count(need[i])) {
			int k = 0;
			for (auto &p : got) {
				k += (p.first > was[need[i]]);
			}
			ans[was[need[i]]] = min(n, timer - was[need[i]] - k);
			got.emplace_back(was[need[i]], timer - was[need[i]] - k);
			//write
			//cout << i + 1 << ": " << timer << " " << was[need[i]] << endl;
			was[need[i]] = timer++;
		} else {
			while (it < n) {
				was[a[it]] = timer++;
				//write
				if (a[it++] == need[i])
					break;
 			}
		}
	}
	cout << timer << endl;
	for (int i = 0; i < timer; i++) {
		cout << (ans[i] == -1 ? n : ans[i]) << " ";
	}
	cout << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n >> m;
	a.resize(n);
	need.resize(m);
	for (int &x : need) {
		cin >> x;
		x--;
	}
	for (int &x : a) {
		cin >> x;
		x--;
	}
	bool fir = n == m;
	bool sec = n == m;
	for (int i = 0; i < min(n, m); i++) {
		if (a[i] != need[i]) {
			fir = false;
		}
		if (a[i] != need[m - i - 1]) {
			sec = false;
		}
	}
	solve_un();
	/*if (fir) 
		solve_fir();
	else if (sec)
		solve_sec();
	else if (n > 2000)
		solve_un();
	else
		solve_sq();*/
	system("pause");
}