#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const long long R = 1e9 + 7;

long long solve(int n, int k) {
	vector<vector<long long>> d(n, vector<long long>(k + 1));
    for (int i = 0; i <= k; i++) {
        d[0][i] = 1;
    }
    for (int i = 1; i < n; i++) {
        for (int j = 0; j <= k; j++) {
            for (int h = 0; h <= k; h++) {
                if ((h & j) == h) {
                    d[i][j] = (d[i][j] + d[i - 1][h]) % R;
                }
            }
        }
    }
    long long ans = 0;
    for (auto &x : d[n - 1]) {
        ans += x;
    }
	return ans % R;
}

long long get(int n, int k) {
	int nn = 10;
	vector<vector<long long>> d(nn, vector<long long>(k + 1));
	for (int i = 0; i <= k; i++) {
		d[0][i] = 1;
	}
	vector<vector<long long>> val(nn, vector<long long>(max(n, nn)));
	val[0][0] = k + 1;
	for (int i = 1; i < nn; i++) {
		for (int j = 0; j <= k; j++) {
			for (int h = 0; h <= k; h++) {
				if ((h & j) == h) {
					d[i][j] = (d[i][j] + d[i - 1][h]) % R;
				}
			}
		}
		long long ans = 0;
		for (auto &x : d[i]) {
			ans += x;
		}
		val[0][i] = ans;
	}
	for (int j = 1; j < nn; j++) {
		for (int h = 0; h < nn - j; h++) {
			val[j][h] = (val[j - 1][h + 1] - val[j - 1][h] + R) % R;
		}
	}
	for (int j = nn - 2; j >= 0; j--) {
		for (int i = 1; i < n - j; i++) {
			val[j][i] = (val[j][i - 1] + val[j + 1][i - 1]) % R;
		}
	}
	return val[0][n - 1];
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, m, k; cin >> n >> m >> k;
	cout << get(n, k) << endl;
	//system("pause");
}