#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;

const long long INF = 1e9;

int n;
int ans = 0;
vector<int> g;

void rec(int ind, vector<int> &ch, int k) {
	if (ind == n) {
		ans = max(ans, k);
		return;
	}
	rec(ind + 1, ch, k);
	if (!ch[ind] && (g[ind] == -1 || ch[g[ind]] < INF)) {
		ch[ind] = INF;
		if (g[ind] != -1) {
			ch[g[ind]]++;
		}
		rec(ind + 1, ch, k + 1);
		ch[ind] = 0;
		if (g[ind] != -1)
			ch[g[ind]]--;
	}
}

int solve_st() {
	vector<int> ch(n);
	rec(0, ch, 0);
	return ans;
}

vector<vector<int>> t;
vector<bool> used;

pair<int, int> dfs(int v, int p, int d) {
	used[v] = true;
	pair<int, int> ans = make_pair(1, 0);
	for (int to : t[v]) {
		if (to != p) {
			auto got = dfs(to, v, d + 1);
			ans.first += ans.second;
			ans.second += ans.first;
		}
	}
	return ans;
}

int solve_f() {
	t.resize(n);
	used.resize(n);
	for (int i = 0; i < n; i++) {
		if (g[i] != -1) {
			t[i].push_back(g[i]);
			t[g[i]].push_back(i);
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (g[i] == -1 && !used[i]) {
			auto got = dfs(i, -1, 0);
			ans += max(got.first, got.second);
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	bool fir = true;
	bool sec = true;
	g.resize(n, -1);
	for (int i = 0; i < n; i++) {
		cin >> g[i];
		if (g[i] != -1)
			g[i]--;
		if (g[i] != i - 1) {
			fir = false;
		}
		if (g[i] > i) {
			sec = false;
		}
	}
	if (fir) {
		cout << (n + 1) / 2 << endl;
	} else if (sec) {
		cout << solve_f() << endl;
	}
	else {
		cout << solve_st() << endl;
	}
	//system("pause");
}